<template>
    <div class='portlet app-ctrl-amount ' :style="{'height': isAdaptiveSize ? 'calc(100% - 16px)' : getHeight,}">
        <div class="portlet-without-title">
        <!-- 测试 -->
              <view_db_sysportlet6_list 
          :viewState="viewState"  
          :viewparams="viewparams" 
          :context="context" 
          createAction="Create"
          removeAction="Remove"
          updateAction="Update"
          fetchAction="FetchDefault"
          :showBusyIndicator="true"
        :parentType="controlType"
          name="db_sysportlet6_list"  
          ref='db_sysportlet6_list' 
          @closeview="closeView($event)">
      </view_db_sysportlet6_list>
        </div>
    </div>
</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util, ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import IBIZAPPCTRLService from '@/service/ibizappctrl/ibizappctrl-service';
import AppCtrlAmountService from './app-ctrl-amount-portlet-service';

import IBIZAPPCTRLUIService from '@/uiservice/ibizappctrl/ibizappctrl-ui-service';
import UIService from '@/uiservice/ui-service';
import { Environment } from '@/environments/environment';


@Component({
    components: {
      
    }
})
export default class IBIZAPPCTRLAppCtrlAmountBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof AppCtrlAmountBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof AppCtrlAmountBase
     */
    public getControlType(): string {
        return 'PORTLET'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof AppCtrlAmountBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {AppCtrlAmountService}
     * @memberof AppCtrlAmountBase
     */
    public service: AppCtrlAmountService = new AppCtrlAmountService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZAPPCTRLService}
     * @memberof AppCtrlAmountBase
     */
    public appEntityService: IBIZAPPCTRLService = new IBIZAPPCTRLService({ $store: this.$store });

    /**
     * 界面UI服务对象
     *
     * @type {IBIZAPPCTRLUIService}
     * @memberof AppCtrlAmountBase
     */  
    public appUIService:IBIZAPPCTRLUIService = new IBIZAPPCTRLUIService(this.$store);
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof AppCtrlAmountBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof AppCtrlAmountBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 长度
     *
     * @type {number}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public height?: number;

    /**
     * 宽度
     *
     * @type {number}
     * @memberof AppCtrlAmountBase
     */
    @Prop() public width?: number;

    /**
     * 门户部件类型
     *
     * @type {number}
     * @memberof AppCtrlAmountBase
     */
    public portletType: string = 'list';

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof AppCtrlAmountBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;


    /**
     * 界面行为模型数据
     *
     * @memberof AppCtrlAmountBase
     */
    public uiactionModel: any = {
    }


    /**
     * 是否自适应大小
     *
     * @returns {boolean}
     * @memberof AppCtrlAmountBase
     */
    @Prop({default: false})public isAdaptiveSize!: boolean;

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof AppCtrlAmountBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof AppCtrlAmountBase
     */
    public getData(): any {
        return {};
    }

    /**
     * 获取高度
     *
     * @returns {any[]}
     * @memberof AppCtrlAmountBase
     */
    get getHeight(){
        if(!this.$util.isEmpty(this.height) && !this.$util.isNumberNaN(this.height)){
            if(this.height == 0){
                return 'auto';
            }else{
                return this.height+'px';
            }
        }else{
            return '100px';
        }
    }

    /**
     * 刷新
     *
     * @memberof AppCtrlAmountBase
     */
    public refresh(args?: any) {
      this.viewState.next({ tag: 'db_sysportlet6_list', action: 'refresh', data: args });
    }

    /**
     * vue 生命周期
     *
     * @memberof AppCtrlAmountBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof AppCtrlAmountBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if(Object.is(tag, "all-portlet") && Object.is(action,'loadmodel')){
                   this.calcUIActionAuthState(data);
                }
                if (!Object.is(tag, this.name)) {
                    return;
                }
                const refs: any = this.$refs;
                Object.keys(refs).forEach((_name: string) => {
                    this.viewState.next({ tag: _name, action: action, data: data });
                });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof AppCtrlAmountBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof AppCtrlAmountBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }


    /**
     * 计算界面行为权限
     *
     * @memberof AppCtrlAmountBase
     */
    public calcUIActionAuthState(data:any = {}) {
        //  如果是操作栏，不计算权限
        if(this.portletType && Object.is('actionbar', this.portletType)) {
            return;
        }
        let _this: any = this;
        let uiservice: any = _this.appUIService ? _this.appUIService : new UIService(_this.$store);
        if(_this.uiactionModel){
            ViewTool.calcActionItemAuthState(data,_this.uiactionModel,uiservice);
        }
    }

}
</script>

<style lang='less'>
@import './app-ctrl-amount-portlet.less';
</style>

